From: Chaitanya Kulkarni <kch@nvidia.com>
To: <linux-block@vger.kernel.org>, <linux-nvme@lists.infradead.org>
Cc: <shinichiro.kawasaki@wdc.com>, Chaitanya Kulkarni <kch@nvidia.com>
Subject: [PATCH] nvme: add nvme pci timeout testcase
Date: Tue, 9 Jan 2024 19:57:56 -0800 [thread overview]
Message-ID: <20240110035756.9537-1-kch@nvidia.com> (raw)
Trigger and test nvme-pci timeout with concurrent fio jobs.
Signed-off-by: Chaitanya Kulkarni <kch@nvidia.com>
---
tests/nvme/050 | 43 +++++++++++++++++++++++++++++++++++++++++++
tests/nvme/050.out | 2 ++
2 files changed, 45 insertions(+)
create mode 100755 tests/nvme/050
create mode 100644 tests/nvme/050.out
diff --git a/tests/nvme/050 b/tests/nvme/050
new file mode 100755
index 0000000..ba54bcd
--- /dev/null
+++ b/tests/nvme/050
@@ -0,0 +1,43 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2024 Chaitanya Kulkarni.
+#
+# Test NVMe-PCI timeout with FIO jobs by triggering the nvme_timeout function.
+#
+
+. tests/nvme/rc
+
+DESCRIPTION="test nvme-pci timeout with fio jobs."
+
+requires() {
+ _require_nvme_trtype pci
+ _have_fio
+ _nvme_requires
+}
+
+test() {
+ local dev="/dev/nvme0n1"
+
+ echo "Running ${TEST_NAME}"
+
+ echo 1 > /sys/block/nvme0n1/io-timeout-fail
+
+ echo 99 > /sys/kernel/debug/fail_io_timeout/probability
+ echo 10 > /sys/kernel/debug/fail_io_timeout/interval
+ echo -1 > /sys/kernel/debug/fail_io_timeout/times
+ echo 0 > /sys/kernel/debug/fail_io_timeout/space
+ echo 1 > /sys/kernel/debug/fail_io_timeout/verbose
+
+ # shellcheck disable=SC2046
+ fio --bs=4k --rw=randread --norandommap --numjobs=$(nproc) \
+ --name=reads --direct=1 --filename=${dev} --group_reporting \
+ --time_based --runtime=1m 2>&1 | grep -q "Input/output error"
+
+ # shellcheck disable=SC2181
+ if [ $? -eq 0 ]; then
+ echo "Test complete"
+ else
+ echo "Test failed"
+ fi
+ modprobe -r nvme
+}
diff --git a/tests/nvme/050.out b/tests/nvme/050.out
new file mode 100644
index 0000000..b78b05f
--- /dev/null
+++ b/tests/nvme/050.out
@@ -0,0 +1,2 @@
+Running nvme/050
+Test complete
--
2.40.0
next reply other threads:[~2024-01-10 3:58 UTC|newest]
Thread overview: 16+ messages / expand[flat|nested] mbox.gz Atom feed top
[not found] <CGME20240110062350epcas5p351f5b4f8e27b3c57545b49509d2a48b6@epcas5p3.samsung.com>
2024-01-10 3:57 ` Chaitanya Kulkarni [this message]
2024-01-10 6:17 ` [PATCH] nvme: add nvme pci timeout testcase Nitesh Shetty
2024-01-10 7:40 ` Chaitanya Kulkarni
2024-01-10 7:54 ` Nitesh Shetty
2024-01-10 8:12 ` Chaitanya Kulkarni
2024-01-10 9:13 ` Shinichiro Kawasaki
2024-01-10 9:24 ` Hannes Reinecke
2024-01-10 23:47 ` Chaitanya Kulkarni
2024-01-10 14:59 ` Jens Axboe
2024-01-10 23:51 ` Chaitanya Kulkarni
2024-01-10 12:23 ` Shinichiro Kawasaki
2024-01-11 0:00 ` Chaitanya Kulkarni
2024-01-11 4:41 ` Shinichiro Kawasaki
2024-01-11 5:01 ` Chaitanya Kulkarni
2024-01-11 1:25 ` Yi Zhang
2024-01-11 3:09 ` Chaitanya Kulkarni
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20240110035756.9537-1-kch@nvidia.com \
--to=kch@nvidia.com \
--cc=linux-block@vger.kernel.org \
--cc=linux-nvme@lists.infradead.org \
--cc=shinichiro.kawasaki@wdc.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox